// ==========================================================================
// $Id: Actionable.java,v 1.1 2002/09/01 15:48:29 hitoshi Exp $
// Time Action abstract class
// ==========================================================================
// Copyright (C) 2002 Yamauchi, Hitoshi
//
//   Max-Planck-Institut fuer Informatik AG4
//   Stuhlsatzenhausweg 85, 66123 Saarbruecken
//   http://www.mpi-sb.mpg.de/
// 
// This software can be redistributed only under GNU copyleft.
//
// @author Yamauchi Hitoshi  
// ==========================================================================
// $Revision: 1.1 $
// $Date: 2002/09/01 15:48:29 $
// $Author: hitoshi $
// ==========================================================================
package de.mpg.mpisb.timerclock;

/** 
 * Actionable 
 *   interface for action
 */
public abstract class Actionable
{
  /**
   * set the action time 
   *  @param acttime elapsed time (millisec)
   */
  public void setActionTime(long acttime)
  {
    this.mActionTime = acttime;
  }

  /**
   * get the action time (millisec)
   */
  public long getActionTime()
  {
    return(this.mActionTime);
  }

  // private variables
  private long mActionTime = 0;

  /*============================================================
   * interface for action
   *===========================================================*/
  /**
   * do the action
   */
  public abstract void doit();

  /**
   * desctiption of this action
   */
  // public abstract String getDescription();
}
