// ==========================================================================
// $Id: AktionColorChange.java,v 1.2 2002/09/09 09:24:34 hitoshi Exp $
// Color change action
// ==========================================================================
// Copyright (C) 2002 Yamauchi, Hitoshi
//
//   Max-Planck-Institut fuer Informatik AG4
//   Stuhlsatzenhausweg 85, 66123 Saarbruecken
//   http://www.mpi-sb.mpg.de/
// 
// This software can be redistributed only under GNU copyleft.
//
// @author Yamauchi Hitoshi  
// ==========================================================================
// $Revision: 1.2 $
// $Date: 2002/09/09 09:24:34 $
// $Author: hitoshi $
// ==========================================================================
package de.mpg.mpisb.timerclock;

import  java.awt.Color;

/**
 * action : color change 
 */
public class AktionColorChange extends Actionable
{
  /**
   * constructor
   */
  public AktionColorChange(long firetime, Color fg, Color bg, TimerClockPanel tcp)
  {
    this.setActionTime(firetime);
    this.mFGColor = fg;
    this.mBGColor = bg;
    this.mTCP     = tcp;
  }

  /**
   * string representation
   */
  public String toString()
  {
    String s = "t = " + this.getActionTime() + 
      ": Change Color. FG = " + this.mFGColor + ", BG = " + this.mBGColor;
    return(s);
  }

  /*============================================================
   * interface for action
   *===========================================================*/
  /**
   * do the action : change the color
   */
  public void doit()
  {
    this.mTCP.changeFGColor(this.mFGColor);
    this.mTCP.changeBGColor(this.mBGColor);
  }

  // private variables
  private Color 	  mFGColor;
  private Color 	  mBGColor;
  private TimerClockPanel mTCP;
}
